

   MEMBER('invoice.clw')                                   ! This is a MEMBER module


   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('INVOICE005.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('INVOICE004.INC'),ONCE        !Req'd for module callout resolution
                     END


UpdateDetail PROCEDURE                                     ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
CheckFlag            BYTE                                  !
LocalRequest         LONG                                  !
FilesOpened          BYTE                                  !
ActionMessage        CSTRING(40)                           !
RecordChanged        BYTE,AUTO                             !
LOC:RegTotalPrice    DECIMAL(9,2)                          !
LOC:DiscTotalPrice   DECIMAL(9,2)                          !
LOC:QuantityAvailable DECIMAL(7,2)                         !Quantity available for sale
SAV:Quantity         DECIMAL(7,2)                          !
NEW:Quantity         DECIMAL(7,2)                          !
SAV:BackOrder        BYTE                                  !
ProductDescription   STRING(35)                            !
History::DTL:Record  LIKE(DTL:RECORD),THREAD
QuickWindow          WINDOW('Update Detail'),AT(,,271,169),FONT('MS Sans Serif',8,COLOR:Black),RESIZE,CENTER,ICON('NOTE14.ICO'), |
  GRAY,IMM,MDI,HLP('~UpdateDetail'),SYSTEM
                       SHEET,AT(3,2,267,164),USE(?CurrentTab),WIZARD
                         TAB('Tab 1'),USE(?Tab1)
                           PROMPT('Product Number:'),AT(9,22),USE(?DTL:ProductNumber:Prompt)
                           ENTRY(@n07),AT(78,21,33,10),USE(DTL:ProductNumber),MSG('Product Identification Number')
                           PROMPT('Description:'),AT(9,35),USE(?ProductDescription:Prompt)
                           STRING(@s35),AT(77,35,64,10),USE(ProductDescription)
                           PROMPT('Tax Paid:'),AT(162,62),USE(?DTL:TaxPaid:Prompt)
                           STRING(@n$-14.2),AT(202,61),USE(DTL:TaxPaid),DISABLE
                           PROMPT('Discount:'),AT(162,76),USE(?DTL:Discount:Prompt)
                           STRING(@n$-14.2),AT(202,75,60,10),USE(DTL:Discount)
                           PROMPT('Savings:'),AT(162,103),USE(?DTL:Savings:Prompt)
                           STRING(@n$-14.2),AT(202,103),USE(DTL:Savings),DISABLE
                           PROMPT('Total Cost:'),AT(162,89),USE(?DTL:TotalCost:Prompt)
                           STRING(@N$-14.2),AT(202,89),USE(DTL:TotalCost)
                           BUTTON('Recalculate Values'),AT(25,97,103,15),USE(?recalc)
                         END
                       END
                       PROMPT('Line Number:'),AT(9,7),USE(?DTL:LineNumber:Prompt)
                       STRING(@n04),AT(77,7,29,10),USE(DTL:LineNumber)
                       BUTTON('...'),AT(116,20,12,11),USE(?CallLookup),FONT('Microsoft Sans Serif',8,COLOR:Navy), |
  ICON(ICON:None),IMM
                       PROMPT('Quantity Ordered:'),AT(9,49),USE(?DTL:QuantityOrdered:Prompt)
                       SPIN(@n9.2B),AT(78,47,33,10),USE(DTL:QuantityOrdered),MSG('Quantity of product ordered'),RANGE(1, |
  99999)
                       PROMPT('Price:'),AT(162,49,19,10),USE(?DTL:Price:Prompt)
                       STRING(@n$-14.2B),AT(202,49,56,10),USE(DTL:Price)
                       PROMPT('Tax Rate:'),AT(9,63),USE(?DTL:TaxRate:Prompt)
                       ENTRY(@n7.4),AT(78,62,33,10),USE(DTL:TaxRate),MSG('Enter Consumer''s Tax rate')
                       STRING('%'),AT(116,76,13,10),USE(?String3),FONT('MS Sans Serif',11,,FONT:bold)
                       PROMPT('Discount Rate:'),AT(9,76),USE(?DTL:DiscountRate:Prompt)
                       ENTRY(@n7.4),AT(78,75,33,10),USE(DTL:DiscountRate),MSG('Enter discount rate')
                       STRING('%'),AT(116,62,13,10),USE(?String4),FONT('MS Sans Serif',11,,FONT:bold)
                       CHECK('Back Ordered'),AT(162,35),USE(DTL:BackOrdered),COLOR(COLOR:Silver),DISABLE,MSG('Product is' & |
  ' on back order')
                       BUTTON,AT(95,132,22,20),USE(?OK),ICON('DISK12.ICO'),DEFAULT,FLAT,TIP('Save record and Exit')
                       BUTTON,AT(128,137,13,12),USE(?Help),ICON(ICON:Help),FLAT,HIDE,STD(STD:Help),TIP('Get Help')
                       BUTTON,AT(152,132,22,20),USE(?Cancel),ICON(ICON:Cross),FLAT,MSG('Cancel changes and Exit'), |
  TIP('Cancel changes and Exit')
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED                 ! Method added to host embed code
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeCompleted          PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeSelected           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
ToolbarForm          ToolbarUpdateClass                    ! Form Toolbar Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------
!Calculate taxes, discounts, and total cost
!----------------------------------------------------------------------
CalcValues  ROUTINE
  IF DTL:TaxRate = 0 THEN
    IF DTL:DiscountRate = 0 THEN
      DTL:TotalCost = DTL:Price * |
                                             DTL:QuantityOrdered
    ELSE
      LOC:RegTotalPrice = DTL:Price * DTL:QuantityOrdered
      DTL:Discount = LOC:RegTotalPrice * |
                                             DTL:DiscountRate / 100
      DTL:TotalCost = LOC:RegTotalPrice - DTL:Discount
      DTL:Savings = LOC:RegTotalPrice - DTL:TotalCost
    END
  ELSE
    IF DTL:DiscountRate = 0 THEN
      LOC:RegTotalPrice = DTL:Price * DTL:QuantityOrdered
      DTL:TaxPaid = LOC:RegTotalPrice * DTL:TaxRate / 100
      DTL:TotalCost = LOC:RegTotalPrice + DTL:TaxPaid
    ELSE
      LOC:RegTotalPrice = DTL:Price * DTL:QuantityOrdered
      DTL:Discount = LOC:RegTotalPrice * |
                                             DTL:DiscountRate / 100
      LOC:DiscTotalPrice = LOC:RegTotalPrice - DTL:Discount
      DTL:TaxPaid = LOC:DiscTotalPrice * DTL:TaxRate / 100
      DTL:TotalCost = LOC:DiscTotalPrice + DTL:TaxPaid
      DTL:Savings = LOC:RegTotalPrice - DTL:TotalCost
    END
  END
!Update InvHist and Products files
!-----------------------------------------------------------------------
UpdateOtherFiles ROUTINE

 PRO:ProductNumber = DTL:ProductNumber
 Access:Products.TryFetch(PRO:KeyProductNumber)
 CASE ThisWindow.Request
 OF InsertRecord
   IF DTL:BackOrdered = FALSE
     PRO:QuantityInStock -= DTL:QuantityOrdered
     IF Access:Products.Update() <> Level:Benign
       STOP(ERROR())
     END !end if
     INV:Date = TODAY()
     INV:ProductNumber = DTL:ProductNumber
     INV:TransType = 'Sale'
     INV:Quantity =- DTL:QuantityOrdered
     INV:Cost = PRO:Cost
     INV:Notes = 'New purchase'
     IF Access:InvHist.Insert() <> Level:Benign
       STOP(ERROR())
     END !end if
   END !end if
 OF ChangeRecord
   IF SAV:BackOrder = FALSE
     PRO:QuantityInStock += SAV:Quantity
     PRO:QuantityInStock -= NEW:Quantity
     IF Access:Products.Update() <> Level:Benign
       STOP(ERROR())
     END
     InvHist.Date = TODAY()
     INV:ProductNumber = DTL:ProductNumber
     INV:TransType = 'Adj.'
     INV:Quantity = (SAV:Quantity - NEW:Quantity)
     INV:Notes = 'Change in quantity purchased'
     IF Access:InvHist.Insert() <> Level:Benign
       STOP(ERROR())
     END !end if
   ELSIF SAV:BackOrder = TRUE AND DTL:BackOrdered = FALSE
     PRO:QuantityInStock -= DTL:QuantityOrdered
     IF Access:Products.Update() <> Level:Benign
       STOP(ERROR())
     END !end if
     INV:Date = TODAY()
     INV:ProductNumber = DTL:ProductNumber
     INV:TransType = 'Sale'
     INV:Quantity =- DTL:QuantityOrdered
     INV:Cost = PRO:Cost
     INV:Notes = 'New purchase'
     IF Access:InvHist.Insert() <> Level:Benign
       STOP(ERROR())
     END !end if
   END ! end if elsif
 OF DeleteRecord
   IF SAV:BackOrder = FALSE
     PRO:QuantityInStock += DTL:QuantityOrdered
     IF Access:Products.Update() <> Level:Benign
       STOP(ERROR())
     END
     INV:Date = TODAY()
     INV:ProductNumber = DTL:ProductNumber
     INV:TransType = 'Adj.'
     INV:Quantity =+ DTL:QuantityOrdered
     INV:Notes = 'Cancelled Order'
     IF Access:InvHist.Insert() <> Level:Benign
       STOP(ERROR())
     END  !End if
   END !End if
 END !End case

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Detail Record'
  OF ChangeRecord
    ActionMessage = 'Changing a Detail Record'
  OF DeleteRecord
    ActionMessage = 'Deleting a Detail Record'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateDetail')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?DTL:ProductNumber:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  !Initializing a variable
  SAV:Quantity = DTL:QuantityOrdered
  SAV:BackOrder = DTL:BackOrdered
  CheckFlag = False
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(DTL:Record,History::DTL:Record)
  SELF.AddHistoryField(?DTL:ProductNumber,4)
  SELF.AddHistoryField(?DTL:TaxPaid,9)
  SELF.AddHistoryField(?DTL:Discount,11)
  SELF.AddHistoryField(?DTL:Savings,12)
  SELF.AddHistoryField(?DTL:TotalCost,13)
  SELF.AddHistoryField(?DTL:LineNumber,3)
  SELF.AddHistoryField(?DTL:QuantityOrdered,5)
  SELF.AddHistoryField(?DTL:Price,7)
  SELF.AddHistoryField(?DTL:TaxRate,8)
  SELF.AddHistoryField(?DTL:DiscountRate,10)
  SELF.AddHistoryField(?DTL:BackOrdered,6)
  SELF.AddUpdateFile(Access:Detail)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:Detail.Open                                       ! File Detail used by this procedure, so make sure it's RelationManager is open
  Relate:InvHist.Open                                      ! File InvHist used by this procedure, so make sure it's RelationManager is open
  Relate:Products.Open                                     ! File Products used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Detail
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.InsertAction = Insert:Query
    SELF.DeleteAction = Delete:Form                        ! Display form on delete
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  IF ThisWindow.Request = ChangeRecord OR ThisWindow.Request = DeleteRecord
    PRO:ProductNumber = DTL:ProductNumber
    Access:Products.TryFetch(PRO:KeyProductNumber)
    ProductDescription = PRO:Description
  END
  Do DefineListboxStyle
  QuickWindow{PROP:MinWidth} = 191                         ! Restrict the minimum window width
  QuickWindow{PROP:MinHeight} = 112                        ! Restrict the minimum window height
  Resizer.Init(AppStrategy:Spread)                         ! Controls will spread out as the window gets bigger
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Detail.Close
    Relate:InvHist.Close
    Relate:Products.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    SelectProducts
    ReturnValue = GlobalResponse
  END
  ! After lookup and out of stock message
  IF GlobalResponse = RequestCompleted
    DTL:ProductNumber = PRO:ProductNumber
    ProductDescription = PRO:Description
    DTL:Price = PRO:Price
    LOC:QuantityAvailable = PRO:QuantityInStock
    DISPLAY
    IF LOC:QuantityAvailable <= 0
      CASE MESSAGE('Yes for BACKORDER or No for CANCEL',|
                   'OUT OF STOCK: Select Order Options',ICON:Question,|
                      BUTTON:Yes+BUTTON:No,BUTTON:Yes,1)
      OF BUTTON:Yes
        DTL:BackOrdered = TRUE
        DISPLAY
        SELECT(?DTL:QuantityOrdered)
      OF BUTTON:No
        IF ThisWindow.Request = InsertRecord
          ThisWindow.Response = RequestCancelled
          Access:Detail.CancelAutoInc
          POST(EVENT:CloseWindow)
        END !If
      END !end case
    END !end if
    IF ThisWindow.Request = ChangeRecord
      IF DTL:QuantityOrdered < LOC:QuantityAvailable
        DTL:BackOrdered = FALSE
        DISPLAY
      ELSE
        DTL:BackOrdered = TRUE
        DISPLAY
      END !end if
    END !end if
    IF ProductDescription = ''
      CLEAR(DTL:Price)
      SELECT(?CallLookup)
    END
    SELECT(?DTL:QuantityOrdered)
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?recalc
           do CalcValues      
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?DTL:ProductNumber
      IF Access:Detail.TryValidateField(4)                 ! Attempt to validate DTL:ProductNumber in Detail
        SELECT(?DTL:ProductNumber)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?DTL:ProductNumber
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?DTL:ProductNumber{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?CallLookup
      ThisWindow.Update
      PRO:ProductNumber = DTL:ProductNumber
      IF SELF.Run(1,SelectRecord) = RequestCompleted       ! Call lookup procedure and verify RequestCompleted
        DTL:ProductNumber = PRO:ProductNumber
      END
      ThisWindow.Reset(1)
    OF ?DTL:QuantityOrdered
      IF Access:Detail.TryValidateField(5)                 ! Attempt to validate DTL:QuantityOrdered in Detail
        SELECT(?DTL:QuantityOrdered)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?DTL:QuantityOrdered
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?DTL:QuantityOrdered{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
      !Initializing a variable
      NEW:Quantity = DTL:QuantityOrdered
       !Low stock message
      IF CheckFlag = FALSE
        IF LOC:QuantityAvailable > 0
          IF DTL:QuantityOrdered > LOC:QuantityAvailable
            CASE MESSAGE('Yes for BACKORDER or No for CANCEL',|
                           'LOW STOCK: Select Order Options',ICON:Question,|
                             BUTTON:Yes+BUTTON:No,BUTTON:Yes,1)
            OF BUTTON:Yes
              DTL:BackOrdered = TRUE
              DISPLAY
            OF BUTTON:No
              IF ThisWindow.Request = InsertRecord
                ThisWindow.Response = RequestCancelled
                Access:Detail.CancelAutoInc
                POST(EVENT:CloseWindow)
              END !
            END !end case
          ELSE
            DTL:BackOrdered = FALSE
            DISPLAY
          END !end if Detail
        END !End if LOC:
        IF ThisWindow.Request = ChangeRecord
          IF DTL:QuantityOrdered <= LOC:QuantityAvailable
            DTL:BackOrdered = FALSE
            DISPLAY
          ELSE
            DTL:BackOrdered = TRUE
            DISPLAY
          END !end if
        END !end if
        CheckFlag = TRUE
      END !end if
    OF ?OK
      ThisWindow.Update
      !Calculate all totals
      DO CalcValues
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeCompleted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
   !Updating other files
    DO UpdateOtherFiles
  ReturnValue = PARENT.TakeCompleted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeSelected PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all Selected events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeSelected()
    CASE FIELD()
    OF ?DTL:ProductNumber
      PRO:ProductNumber = DTL:ProductNumber
      IF Access:Products.TryFetch(PRO:KeyProductNumber)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          DTL:ProductNumber = PRO:ProductNumber
        END
      END
      ThisWindow.Reset
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.DeferMoves = False
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

